@echo off
set op_Iterations=10000
set op_Timeout=60
set op_Beep=TRUE
set op_indPrimeLog=FALSE
set op_connect=FALSE

set p_file=primes.txt
if %op_indPrimeLog%==TRUE goto set_done
set p_file=..\primes.txt
:set_done

if %op_Iterations%==10000 goto set_done2
if not exist llr.ini goto set_done1
type llr.ini | find /v "OutputIterations=" > llr.new
:set_done1
echo OutputIterations=%op_Iterations%>> llr.new
move /Y llr.new llr.ini >nul
:set_done2

cls
echo +-------------------------------------+
echo ^| LLRnet client V0.9b7 with cLLR V3.8 ^|
echo ^| K.Bonath, 2010-05-15, Version 0.73  ^|
echo +-------------------------------------+
echo.
echo Current configuration:
findstr /b "server" llr-clientconfig.txt
findstr /b "port" llr-clientconfig.txt
findstr /b "username" llr-clientconfig.txt
findstr /b "WUCacheSize" llr-clientconfig.txt
echo.

if %1:==-c: goto jobcancel
if not exist workfile.txt goto do_llrnet

:start

REM found a LLR save-file -> do LLR
if exist z* goto do_cllr

if exist workfile.txt goto do_cllr

REM convert LLR-resultfile into LLRnet-result file
if not exist lresults.txt goto error_nolres
gawk.exe -f do_tosend.awk lresults.txt
del workfile.bak

REM add current results to history
type lresults.txt >>lresults_hist.txt

REM delete old files
del lresults.txt, workfile.txt, llr.ini

REM receive/submit workunits from/to LLRnet-server
if not exist tosend.txt goto error_notos
echo OutputIterations=%op_Iterations% >llr.ini

:do_llrnet
llrnet.exe
if not exist tosend.txt goto do_llrnet1
for %%F in (tosend.txt) do set wsize=%%~zF
if %wsize% GTR 1 goto error_noconnection

REM should be empty, but also delete
if exist tosend.txt del tosend.txt

:do_llrnet1
if not exist workfile.txt goto error_noconnection

REM LLR processes all reserved workunits
:do_cllr
if not exist workfile.txt goto error_nowork
cllr.exe -d workfile.txt
set /p =[%Date:~-4%-%Date:~-7,2%-%Date:~-10,2% %Time:~,8%] <nul >>lresults.txt

if not exist workfile.res goto no_prime
for %%F in (workfile.res) do set wsize=%%~zF
if %wsize% LSS 30 goto no_prime

gawk.exe "index($0,\" \")>0 {print strftime(\"[%%Y-%%m-%%d %%H:%%M:%%S]\")\" \"$0}" workfile.res >>%p_file%
del workfile.res
if %op_Beep%==TRUE echo 

:no_prime
ren workfile.txt workfile.bak
goto start

REM ###############################
REM Submit all results and
REM cancel all reserved workunits
REM ###############################
:jobcancel

if not exist lresults.txt goto jobcancel1
copy workfile.txt workfile.bak >nul
gawk.exe -f do_tosend.awk lresults.txt
type lresults.txt >>lresults_hist.txt
del lresults.txt

if not exist workfile.res goto jobcancel1
for %%F in (workfile.res) do set wsize=%%~zF
if %wsize% LSS 30 goto jobcancel1
gawk "index($0,\" \")>0 {print strftime(\"[%%Y-%%m-%%d %%H:%%M:%%S]\")\" \"$0}" workfile.res >>%p_file%
del workfile.res

:jobcancel1
if not exist tosend.txt copy nul tosend.txt >nul
set /p =[%Date:~-4%-%Date:~-7,2%-%Date:~-10,2% %Time:~,8%] <nul >>lresults_hist.txt
gawk -f do_clearwork.awk tosend.txt
move /Y workfile.new workfile.txt >nul

:jobcancel2
if exist workfile.txt goto jobcancel3
echo There're no jobs to cancel!
goto bye

:jobcancel3
llrnet.exe -c
echo All jobs cancelled!
del tosend.txt, workfile.txt, workfile.bak, llr.ini, z*
goto bye

REM ###############################
REM ERRORS here
REM ###############################

:error_noconnection
echo No pairs are available at this time.
echo Either the server has dried out or there is a connecting problem.
if not exist tosend.txt goto error_noconnection1
for %%F in (tosend.txt) do set wsize=%%~zF
if %wsize% LSS 1 goto error_noconnection1
echo The file 'tosend.txt' contains unsent pairs!
echo Starting this script will submit those pairs to the server.
:error_noconnection1
if %op_connect%==FALSE goto bye
echo Sleeping %op_Timeout% seconds before trying again.
waits %op_Timeout%
goto do_llrnet

:error_nowork
echo ERROR: No workfile.txt found for LLR!
goto bye

:error_nolres
echo ERROR: No lresults.txt found for conversion!
goto bye

:error_notos
echo ERROR: No tosend.txt found for submitting to LLRnet-server!

:bye
if %op_Beep%==FALSE goto byebye
echo 
waits 1
echo 
waits 1
echo 
:byebye
